/*
 * generic callback functions for seemon2 
 * Time-stamp: <2005-02-09 11:21:45 dimm>
 * 2002.11.07 -
 */

#include <stdlib.h>
#include <gtk/gtk.h>
#include "seemon2.h"

/* sample callback */
void callback( GtkWidget *widget,
               gpointer   data )
{
    g_print ("Hello again - %s was pressed\n", (gchar *) data);
}

/* quit gtk_main */
gint delete_event( GtkWidget *widget,
                   GdkEvent  *event,
                   gpointer   data )
{
  GtkWidget* dialog;
  gint reply;
  int ret;
  char key[10];

  dialog = gtk_message_dialog_new(NULL, 
				  GTK_DIALOG_MODAL, 
				  GTK_MESSAGE_QUESTION,
				  GTK_BUTTONS_YES_NO, 
				  "Are you sure to quit Seemon2?");
  reply = gtk_dialog_run (GTK_DIALOG (dialog));
  gtk_widget_destroy (dialog);

  if (reply == GTK_RESPONSE_YES) {
    gtk_main_quit ();

    /* stop telescope */
    if (mseemon.tel_stat > 0) {
      unlinkTel();
    }

    /* send quit signal to finder_comm */
    /* added v0.5.5 2004.02.18 */
    if (fd_socket >= 0) {
      printf("# sending finder_comm a quit signal.\n");
      if (fout != NULL) {
	fprintf(fout, "# sending finder_comm a quit signal.\n");
      }
      strcpy(key, "quit");
      write(fd_socket, key, sizeof(key));

      sleep(1);

      ret = disconnect_socket();
      if (ret != EXIT_SUCCESS) {
	printf("# error in disconnecting socket.\n");
	if (fout != NULL) {
	  fprintf(fout, "# error in disconnecting socket.\n");
	}
      }
    }

    /* write finder target position to a file */
    set_finder_target_pos();
  }
}

/* open window */
void callback_open_window (GtkWidget *widget, gpointer data)
{
  gtk_widget_show((GtkWidget*)data);
}

/* hide window */
void callback_hide_window (GtkWidget *widget, gpointer data)
{
  gtk_widget_hide((GtkWidget*)data);
}

/* close window */
void callback_close_window(GtkWidget *widget, gpointer data)
{
  gtk_widget_destroy(GTK_WIDGET(data));
}


/* preference panel */
void callback_open_setting(GtkWidget *widget) {
  GtkWidget *dialog_setup;  /* preferences */

  dialog_setup = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (dialog_setup), "Seemon2: Settings");
  gtk_container_set_border_width (GTK_CONTAINER (dialog_setup), 2);

  /* open the preference panel */
  init_setup_dialog(dialog_setup);

}

/* generic info dialog */
void mydialog(char *str) {
  GtkWidget* dialog;
  gint reply;

  dialog = gtk_message_dialog_new(NULL, GTK_DIALOG_MODAL, 
				  GTK_MESSAGE_INFO, 
				  GTK_BUTTONS_OK, 
				  (gchar*)str);
  gtk_dialog_run(GTK_DIALOG(dialog));
  gtk_widget_destroy(dialog);
}

void user_quit(void) {
  delete_event(NULL, NULL, NULL);
}

