/* 
 * operation mode
 *
 * 2003.07.29 - 
 * Time-stamp: <2005-01-12 23:12:55 dimm>
 *
 */
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <math.h>

#include "seemon2.h"


GtkWidget *dialog, *rb[3], *ent_h, *ent_m;

void toggle_opbutton(GtkWidget *widget, gpointer data)
{
  if (mseemon.opmode == 0) {
    /* check telescope status */
    if (mseemon.tel_stat == 0) {
      mydialog("telescope is disconnected.");
    } else {
      /* determine star_selection mode and end time */
      init_starsel_dialog(); /* in opmode.c */
    }
  } else {
    gtk_entry_set_text(GTK_ENTRY(ent_opmode), "Manual");
    mseemon.opmode = 0;
    mseemon.is_pointing = 0;
  }

  /* update displays */
  update_main_displays(); /* in opmode.c */
}


/* callback for guide function toggle button 
 * 2003.08.15
 */
void toggle_guidebutton(GtkWidget *widget, gpointer data)
{
  if (mseemon.guideflg == 0) {
    gtk_entry_set_text(GTK_ENTRY(ent_guidemode), "ON ");
    mseemon.guideflg = 1;
  } else {
    gtk_entry_set_text(GTK_ENTRY(ent_guidemode), "OFF");
    mseemon.guideflg = 0;
  }
}

/* auto-select star setting dialog
 * v.0.5.3 2003.10.03
 */
int init_starsel_dialog(void) {
  GSList *group = NULL;
  GtkWidget *separator;
  GtkWidget *dialog_action_area, *vbox, *hbox;
  GtkWidget *label, *button;
  gint i;
  gchar *text[3] = {"Auto Select", "Point to Current Selected", "Already Pointed"};
  gchar str[2];
  int endh, endm;

  dialog = gtk_dialog_new();
  gtk_window_set_resizable(GTK_WINDOW(dialog), FALSE);
  gtk_window_set_modal(GTK_WINDOW(dialog), TRUE);

  dialog_action_area = GTK_DIALOG(dialog)->action_area;
  vbox = GTK_DIALOG(dialog)->vbox;

  rb[0] = gtk_radio_button_new_with_label(NULL, text[0]);
  if (mseemon.op_ssmode == 0) {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(rb[0]), TRUE);
  }
  gtk_box_pack_start(GTK_BOX(vbox), rb[0], TRUE, TRUE, 0);
  gtk_widget_show(rb[0]);

  group = gtk_radio_button_get_group(GTK_RADIO_BUTTON(rb[0]));
  rb[1] = gtk_radio_button_new_with_label(group, text[1]);
  if (mseemon.op_ssmode == 1) {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(rb[1]), TRUE);
  }
  gtk_box_pack_start(GTK_BOX(vbox), rb[1], TRUE, TRUE, 0);
  gtk_widget_show(rb[1]);

  rb[2] = gtk_radio_button_new_with_label_from_widget(GTK_RADIO_BUTTON(rb[1]), text[2]);
  if (mseemon.op_ssmode == 2) {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(rb[2]), TRUE);
  }
  gtk_box_pack_start(GTK_BOX(vbox), rb[2], TRUE, TRUE, 0);
  gtk_widget_show(rb[2]);

  separator = gtk_hseparator_new();
  gtk_box_pack_start(GTK_BOX(vbox), separator, FALSE, TRUE, 0);
  gtk_widget_show(separator);

  label = gtk_label_new("Time to End Operation");
  gtk_box_pack_start(GTK_BOX(vbox), label, FALSE, FALSE, 1);
  gtk_widget_show(label);

  endh = (int)mseemon.endtime;
  endm = (int)((mseemon.endtime-endh)*60.);
  hbox = gtk_hbox_new(FALSE, 0);
  ent_h = gtk_entry_new();
  gtk_entry_set_width_chars(GTK_ENTRY(ent_h), 2);
  sprintf(str, "%02d", endh);
  gtk_entry_set_text(GTK_ENTRY(ent_h), str);
  gtk_widget_show(ent_h);
  gtk_box_pack_start(GTK_BOX(hbox), ent_h, TRUE, FALSE, 1);

  label = gtk_label_new(":");
  gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 1);
  gtk_widget_show(label);

  ent_m = gtk_entry_new();
  gtk_entry_set_width_chars(GTK_ENTRY(ent_m), 2);
  sprintf(str, "%02d", endm);
  gtk_entry_set_text(GTK_ENTRY(ent_m), str);
  gtk_box_pack_start(GTK_BOX(hbox), ent_m, TRUE, FALSE, 1);
  gtk_widget_show(ent_m);

  gtk_box_pack_start(GTK_BOX(vbox), hbox, TRUE, TRUE, 5);
  gtk_widget_show(hbox);
  gtk_widget_show(vbox);

  hbox = gtk_hbox_new (FALSE, 0);
  /* cancel button */
  button = gtk_button_new_with_label ("Cancel");
  gtk_signal_connect(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(dialog_click_cancel), dialog);
  gtk_box_pack_start(GTK_BOX (hbox), button, TRUE, TRUE, 2);
  gtk_widget_show(button);

  /* ok button */
  button = gtk_button_new_with_label ("Ok");
  gtk_signal_connect(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(dialog_click_ok), dialog);
  gtk_box_pack_start(GTK_BOX (hbox), button, TRUE, TRUE, 2);
  gtk_widget_show(button);

  gtk_box_pack_start(GTK_BOX(dialog_action_area), hbox, TRUE, TRUE, 2);
  gtk_widget_show(hbox);

  gtk_widget_show(dialog);
  gtk_grab_add(GTK_WIDGET(dialog));

  return(EXIT_SUCCESS);

}


/* click cancel */
void dialog_click_cancel (GtkWidget *widget, gpointer data)
{
  gtk_widget_destroy(GTK_WIDGET(data));
}

/* click ok
 * set interval, site lon and lat */
void dialog_click_ok (GtkWidget *widget, gpointer data)
{
  gchar text[128];
  gchar* content;
  int h, m, i, sel;
  double val;

  sel = -1;
  for (i = 0; i < 3; i++) {
    if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(rb[i])) == TRUE) {
      sel = i;
    }
  }

  #ifdef DEBUG
  printf("selected: %d\n", sel);
  #endif
  mseemon.op_ssmode = sel;

  content = (gchar*)gtk_entry_get_text(GTK_ENTRY(ent_h));
  h = atoi(content);

  content = (gchar*)gtk_entry_get_text(GTK_ENTRY(ent_m));
  m = atoi(content);

  val = h + m/60.;
  mseemon.endtime = val;

  #ifdef DEBUG
  printf("end time: %5.2f\n", mseemon.endtime);
  #endif

  gtk_entry_set_text(GTK_ENTRY(ent_opmode), "Automatic");
  mseemon.opmode = 1;

  /* added v0.5.7 2004.02.21 */
  if (mseemon.op_ssmode == 0) {  /* autoselect a star */
    mseemon.tel_stat = 1;
    mseemon.is_pointing = 1;
  }

  if (mseemon.op_ssmode == 1) {  /* point to currently selected */
    mseemon.tel_stat = 1; /* connected, not pointed */
    mseemon.is_pointing = 2;
#ifdef DEBUG
    printf("### is_pointing ==> 2 opmode.c 205\n");
#endif
  }

  /* added v0.5.7 2004.02.21 */
  if (mseemon.op_ssmode == 2) {  /* already pointed */
    mseemon.tel_stat = 2; /* pointed */
    mseemon.is_pointing = 3;
  }

  gtk_widget_destroy(GTK_WIDGET(data));
}


/* update displays in Main Window 
 * v0.5.4 2003.10.04
 */
void update_main_displays(void) {
  gchar text[128];
  gchar* content;

  if (mseemon.opmode == 1) {
    gtk_entry_set_text(GTK_ENTRY(ent_opmode), "Automatic");
  } else {
    gtk_entry_set_text(GTK_ENTRY(ent_opmode), "Manual");
  }

  if (mseemon.guideflg == 1) {
    gtk_entry_set_text(GTK_ENTRY(ent_guidemode), "ON ");
  } else {
    gtk_entry_set_text(GTK_ENTRY(ent_guidemode), "OFF");
  }

  update_tel_stat_entry(); /* in telctl_callbacks.c */

  if (mseemon.selnum >= 0) {
    strcpy(text, obj_edb[mseemon.selnum]->o_name);
  } else {
    strcpy(text, "None");
  }
  content = text;
  gtk_entry_set_text (GTK_ENTRY (ent_selobj1), content);
}
    
