/* 
 * preferences panel 
 *
 * 2003.01.23 -
 * Time-stamp: <2005-02-09 11:32:45 dimm>
 *
 */

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <gtk/gtk.h>

#include "seemon2.h"

void dialog_setup_destroy (GtkWidget *widget, gpointer data);
void dialog_setup_click_cancel (GtkWidget *widget, gpointer data);
void dialog_setup_click_ok (GtkWidget *widget, gpointer data);
void callback_setfilepath (GtkWidget *widget, gpointer data);
void filepath_click_ok(GtkWidget *widget, gpointer data);

/* initialization of pref. panel
 *
 */
int init_setup_dialog(GtkWidget *dialog_setup) {
  GtkWidget *button;
  GtkWidget *label1;
  GtkWidget *hbox1, *vbox1;
  GtkWidget *action_area1;
  GtkWidget *entry1;
  GtkWidget *text_area;

  int deg, min, sec;
  int decimal, sign;
  gchar str[4], filepathstr[256];

  gtk_window_set_policy(GTK_WINDOW(dialog_setup), FALSE, FALSE, TRUE);

  hbox1 = gtk_hbox_new (FALSE, 0);
  vbox1 = GTK_DIALOG(dialog_setup)->vbox;
  action_area1 = GTK_DIALOG(dialog_setup)->action_area;


  /* time for reload image */
  label1 = gtk_label_new("DV Reload Interval ");
  gtk_widget_show(label1);
  gtk_box_pack_start(GTK_BOX(hbox1), label1, FALSE, FALSE, 1);
  ent_intv = gtk_entry_new();
  gtk_entry_set_width_chars(GTK_ENTRY(ent_intv), 4);
  sprintf(str, "%d", mseemon.time_reload1);
  gtk_entry_set_text(GTK_ENTRY(ent_intv), str);
  gtk_widget_show(ent_intv);
  gtk_box_pack_start(GTK_BOX(hbox1), ent_intv, TRUE, FALSE, 1);
  label1 = gtk_label_new("msec");
  gtk_widget_show(label1);
  gtk_box_pack_start(GTK_BOX(hbox1), label1, FALSE, FALSE, 1);
  gtk_box_pack_start(GTK_BOX(vbox1), hbox1, TRUE, TRUE, 2);
  gtk_widget_show(hbox1);

  /* time interval for analysis, v0.4.0u 2003.05.17 */
  hbox1 = gtk_hbox_new (FALSE, 0);
  label1 = gtk_label_new("Analysis Interval ");
  gtk_widget_show(label1);
  gtk_box_pack_start(GTK_BOX(hbox1), label1, FALSE, FALSE, 1);
  ent_intv2 = gtk_entry_new();
  gtk_entry_set_width_chars(GTK_ENTRY(ent_intv2), 4);
  sprintf(str, "%d", mseemon.time_reload2);
  gtk_entry_set_text(GTK_ENTRY(ent_intv2), str);
  gtk_widget_show(ent_intv2);
  gtk_box_pack_start(GTK_BOX(hbox1), ent_intv2, TRUE, FALSE, 1);
  label1 = gtk_label_new("msec");
  gtk_widget_show(label1);
  gtk_box_pack_start(GTK_BOX(hbox1), label1, FALSE, FALSE, 1);
  gtk_box_pack_start(GTK_BOX(vbox1), hbox1, TRUE, TRUE, 2);
  gtk_widget_show(hbox1);


  /* time interval for I.I.CCD, v0.5.12 2004.11.18 */
  hbox1 = gtk_hbox_new (FALSE, 0);
  label1 = gtk_label_new("def. IICCD Shutter ");
  gtk_widget_show(label1);
  gtk_box_pack_start(GTK_BOX(hbox1), label1, FALSE, FALSE, 1);
  ent_intv3 = gtk_entry_new();
  gtk_entry_set_width_chars(GTK_ENTRY(ent_intv3), 4);
  sprintf(str, "%d", mseemon.time_iishutter0);
  gtk_entry_set_text(GTK_ENTRY(ent_intv3), str);
  gtk_widget_show(ent_intv3);
  gtk_box_pack_start(GTK_BOX(hbox1), ent_intv3, TRUE, FALSE, 1);
  label1 = gtk_label_new("usec");
  gtk_widget_show(label1);
  gtk_box_pack_start(GTK_BOX(hbox1), label1, FALSE, FALSE, 1);
  gtk_box_pack_start(GTK_BOX(vbox1), hbox1, TRUE, TRUE, 2);
  gtk_widget_show(hbox1);

  /* sigma clipping factor */
  /* added on ver.0.2.6 */
  hbox1 = gtk_hbox_new (FALSE, 0);
  label1 = gtk_label_new("Clipping ");
  gtk_widget_show(label1);
  gtk_box_pack_start(GTK_BOX(hbox1), label1, FALSE, FALSE, 1);
  ent_clip = gtk_entry_new();
  gtk_entry_set_width_chars(GTK_ENTRY(ent_clip), 4);
  sprintf(str, "%4.2f", mseemon.clip);
  gtk_entry_set_text(GTK_ENTRY(ent_clip), str);
  gtk_widget_show(ent_clip);
  gtk_box_pack_start(GTK_BOX(hbox1), ent_clip, TRUE, FALSE, 1);
  label1 = gtk_label_new("sigma");
  gtk_widget_show(label1);
  gtk_box_pack_start(GTK_BOX(hbox1), label1, FALSE, FALSE, 1);
  gtk_box_pack_start(GTK_BOX(vbox1), hbox1, TRUE, TRUE, 2);
  gtk_widget_show(hbox1);


  /* search rectangle size */
  hbox1 = gtk_hbox_new (FALSE, 0);
  label1 = gtk_label_new("Star Rectangle Width  ");
  gtk_widget_show(label1);
  gtk_box_pack_start(GTK_BOX(hbox1), label1, FALSE, FALSE, 1);
  ent_wid = gtk_entry_new();
  gtk_entry_set_width_chars(GTK_ENTRY(ent_wid), 4);
  sprintf(str, "%d", mseemon.star_rect[0].cx);
  gtk_entry_set_text(GTK_ENTRY(ent_wid), str);
  gtk_widget_show(ent_wid);
  gtk_box_pack_start(GTK_BOX(hbox1), ent_wid, TRUE, FALSE, 1);
  label1 = gtk_label_new("pix");
  gtk_widget_show(label1);
  gtk_box_pack_start(GTK_BOX(hbox1), label1, FALSE, FALSE, 1);

  label1 = gtk_label_new(" Height ");
  gtk_widget_show(label1);
  gtk_box_pack_start(GTK_BOX(hbox1), label1, FALSE, FALSE, 1);
  ent_hgt = gtk_entry_new();
  gtk_entry_set_width_chars(GTK_ENTRY(ent_hgt), 4);
  sprintf(str, "%d", mseemon.star_rect[0].cy);
  gtk_entry_set_text(GTK_ENTRY(ent_hgt), str);
  gtk_widget_show(ent_hgt);
  gtk_box_pack_start(GTK_BOX(hbox1), ent_hgt, TRUE, FALSE, 1);
  label1 = gtk_label_new("pix");
  gtk_widget_show(label1);
  gtk_box_pack_start(GTK_BOX(hbox1), label1, FALSE, FALSE, 1);

  gtk_box_pack_start(GTK_BOX(vbox1), hbox1, TRUE, TRUE, 2);
  gtk_widget_show(hbox1);

  /* cg rectangle size */
  hbox1 = gtk_hbox_new (FALSE, 0);
  label1 = gtk_label_new("CG Rectangle Width  ");
  gtk_widget_show(label1);
  gtk_box_pack_start(GTK_BOX(hbox1), label1, FALSE, FALSE, 1);
  ent_cgwid = gtk_entry_new();
  gtk_entry_set_width_chars(GTK_ENTRY(ent_cgwid), 4);
  sprintf(str, "%d", mseemon.cg_rect[0].cx);
  gtk_entry_set_text(GTK_ENTRY(ent_cgwid), str);
  gtk_widget_show(ent_cgwid);
  gtk_box_pack_start(GTK_BOX(hbox1), ent_cgwid, TRUE, FALSE, 1);
  label1 = gtk_label_new("pix");
  gtk_widget_show(label1);
  gtk_box_pack_start(GTK_BOX(hbox1), label1, FALSE, FALSE, 1);

  label1 = gtk_label_new(" Height ");
  gtk_widget_show(label1);
  gtk_box_pack_start(GTK_BOX(hbox1), label1, FALSE, FALSE, 1);
  ent_cghgt = gtk_entry_new();
  gtk_entry_set_width_chars(GTK_ENTRY(ent_cghgt), 4);
  sprintf(str, "%d", mseemon.cg_rect[0].cy);
  gtk_entry_set_text(GTK_ENTRY(ent_cghgt), str);
  gtk_widget_show(ent_cghgt);
  gtk_box_pack_start(GTK_BOX(hbox1), ent_cghgt, TRUE, FALSE, 1);
  label1 = gtk_label_new("pix");
  gtk_widget_show(label1);
  gtk_box_pack_start(GTK_BOX(hbox1), label1, FALSE, FALSE, 1);

  gtk_box_pack_start(GTK_BOX(vbox1), hbox1, TRUE, TRUE, 2);
  gtk_widget_show(hbox1);

  /* background threshold */
  hbox1 = gtk_hbox_new (FALSE, 0);
  label1 = gtk_label_new("Backg-Sub sigma ");
  gtk_widget_show(label1);
  gtk_box_pack_start(GTK_BOX(hbox1), label1, FALSE, FALSE, 1);
  ent_bgsig = gtk_entry_new();
  gtk_entry_set_width_chars(GTK_ENTRY(ent_bgsig), 4);
  sprintf(str, "%4.1f", bgthr);
  gtk_entry_set_text(GTK_ENTRY(ent_bgsig), str);
  gtk_widget_show(ent_bgsig);
  gtk_box_pack_start(GTK_BOX(hbox1), ent_bgsig, TRUE, FALSE, 1);
  gtk_box_pack_start(GTK_BOX(vbox1), hbox1, TRUE, TRUE, 2);
  gtk_widget_show(hbox1);

  /* min. peak value */
  hbox1 = gtk_hbox_new (FALSE, 0);
  label1 = gtk_label_new("Min. Peak Count ");
  gtk_widget_show(label1);
  gtk_box_pack_start(GTK_BOX(hbox1), label1, FALSE, FALSE, 1);
  ent_minpeak = gtk_entry_new();
  gtk_entry_set_width_chars(GTK_ENTRY(ent_minpeak), 4);
  sprintf(str, "%4d", mseemon.min_peak);
  gtk_entry_set_text(GTK_ENTRY(ent_minpeak), str);
  gtk_widget_show(ent_minpeak);
  gtk_box_pack_start(GTK_BOX(hbox1), ent_minpeak, TRUE, FALSE, 1);
  gtk_box_pack_start(GTK_BOX(vbox1), hbox1, TRUE, TRUE, 2);
  gtk_widget_show(hbox1);

  /* finder target position */
  hbox1 = gtk_hbox_new (FALSE, 0);
  label1 = gtk_label_new("Finder Target Pos.X:");
  gtk_box_pack_start(GTK_BOX(hbox1), label1, FALSE, FALSE, 1);
  gtk_widget_show(label1);
  ent_fndr_targetx = gtk_entry_new();
  gtk_entry_set_width_chars(GTK_ENTRY(ent_fndr_targetx), 4);
  sprintf(str, "%4d", mseemon.finder_targetpos.cx);
  gtk_entry_set_text(GTK_ENTRY(ent_fndr_targetx), str);
  gtk_box_pack_start(GTK_BOX(hbox1), ent_fndr_targetx, TRUE, FALSE, 1);
  gtk_widget_show(ent_fndr_targetx);
  label1 = gtk_label_new("Y:");
  gtk_box_pack_start(GTK_BOX(hbox1), label1, FALSE, FALSE, 1);
  gtk_widget_show(label1);
  ent_fndr_targety = gtk_entry_new();
  gtk_entry_set_width_chars(GTK_ENTRY(ent_fndr_targety), 4);
  sprintf(str, "%4d", mseemon.finder_targetpos.cy);
  gtk_entry_set_text(GTK_ENTRY(ent_fndr_targety), str);
  gtk_box_pack_start(GTK_BOX(hbox1), ent_fndr_targety, TRUE, FALSE, 1);
  gtk_widget_show(ent_fndr_targety);

  gtk_box_pack_start(GTK_BOX(vbox1), hbox1, TRUE, TRUE, 2);
  gtk_widget_show(hbox1);

  /* put site longtude as strings */
  hbox1 = gtk_hbox_new (FALSE, 0);
  label1 = gtk_label_new("Site Longitude ");
  gtk_widget_show(label1);
  gtk_box_pack_start(GTK_BOX(hbox1), label1, FALSE, FALSE, 1);

  deg = (int)(msite.slon);
  min = (int)((msite.slon-deg)*60.);
  sec = (int)(((msite.slon-deg)*60.-min)*60.);

  sprintf(str, "%d", deg);
  ent1 = gtk_entry_new();
  gtk_entry_set_width_chars(GTK_ENTRY(ent1), 3);
  gtk_entry_set_text(GTK_ENTRY(ent1), str);
  gtk_widget_show(ent1);
  gtk_box_pack_start(GTK_BOX(hbox1), ent1, TRUE, FALSE, 1);

  sprintf(str, "%d", min);
  ent2 = gtk_entry_new();
  gtk_entry_set_width_chars(GTK_ENTRY(ent2), 2);
  gtk_entry_set_text(GTK_ENTRY(ent2), str);
  gtk_widget_show(ent2);
  gtk_box_pack_start(GTK_BOX(hbox1), ent2, TRUE, FALSE, 1);

  sprintf(str, "%d", sec);
  ent3 = gtk_entry_new();
  gtk_entry_set_width_chars(GTK_ENTRY(ent3), 2);
  gtk_entry_set_text(GTK_ENTRY(ent3), str);
  gtk_widget_show(ent3);
  gtk_box_pack_start(GTK_BOX(hbox1), ent3, TRUE, FALSE, 1);
  gtk_box_pack_start(GTK_BOX(vbox1), hbox1, TRUE, TRUE, 2);
  gtk_widget_show(hbox1);

  /* put site latitude as strings */
  hbox1 = gtk_hbox_new (FALSE, 0);
  label1 = gtk_label_new("Site Latitude  ");
  gtk_widget_show(label1);
  gtk_box_pack_start(GTK_BOX(hbox1), label1, FALSE, FALSE, 1);

  deg = (int)(msite.slat);
  min = (int)((msite.slat-deg)*60.);
  sec = (int)(((msite.slat-deg)*60.-min)*60.);

  sprintf(str, "%d", deg);
  ent4 = gtk_entry_new();
  gtk_entry_set_width_chars(GTK_ENTRY(ent4), 3);
  gtk_entry_set_text(GTK_ENTRY(ent4), str);
  gtk_widget_show(ent4);
  gtk_box_pack_start(GTK_BOX(hbox1), ent4, TRUE, FALSE, 1);

  sprintf(str, "%d", min);
  ent5 = gtk_entry_new();
  gtk_entry_set_width_chars(GTK_ENTRY(ent5), 2);
  gtk_entry_set_text(GTK_ENTRY(ent5), str);
  gtk_widget_show(ent5);
  gtk_box_pack_start(GTK_BOX(hbox1), ent5, TRUE, FALSE, 1);

  sprintf(str, "%d", sec);
  ent6 = gtk_entry_new();
  gtk_entry_set_width_chars(GTK_ENTRY(ent6), 2);
  gtk_entry_set_text(GTK_ENTRY(ent6), str);
  gtk_widget_show(ent6);
  gtk_box_pack_start(GTK_BOX(hbox1), ent6, TRUE, FALSE, 1);

  gtk_box_pack_start(GTK_BOX(vbox1), hbox1, TRUE, TRUE, 2);
  gtk_widget_show(hbox1);

  /* path for star list */
  label1 = gtk_label_new("Obj File ");
  gtk_box_pack_start(GTK_BOX(vbox1), label1, TRUE, TRUE, 2);
  gtk_widget_show(label1);

  hbox1 = gtk_hbox_new (FALSE, 0);

  strcpy(filepathstr, edbpath);
  ent7 = gtk_entry_new();
  gtk_entry_set_width_chars(GTK_ENTRY(ent7), 25);
  gtk_entry_set_text(GTK_ENTRY(ent7), filepathstr);
  gtk_box_pack_start(GTK_BOX(hbox1), ent7, TRUE, FALSE, 1);
  gtk_widget_show(ent7);

  button = gtk_button_new_with_label ("Select..");
  gtk_signal_connect(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(callback_setfilepath), dialog_setup);
  gtk_box_pack_start(GTK_BOX (hbox1), button, TRUE, TRUE, 2);
  gtk_widget_show(button);

  gtk_box_pack_start(GTK_BOX(vbox1), hbox1, TRUE, TRUE, 2);
  gtk_widget_show(hbox1);


  /* extending factor for longer motion time, v0.5.10 2004.08.02 */
  hbox1 = gtk_hbox_new (FALSE, 0);
  label1 = gtk_label_new("Extra Motion ");
  gtk_widget_show(label1);
  gtk_box_pack_start(GTK_BOX(hbox1), label1, FALSE, FALSE, 1);
  ent_ext1 = gtk_entry_new();
  gtk_entry_set_width_chars(GTK_ENTRY(ent_ext1), 4);
  sprintf(str, "%d", mseemon.high_extra);
  gtk_entry_set_text(GTK_ENTRY(ent_ext1), str);
  gtk_widget_show(ent_ext1);
  gtk_box_pack_start(GTK_BOX(hbox1), ent_ext1, TRUE, FALSE, 1);
  label1 = gtk_label_new("for Alt ");
  gtk_widget_show(label1);
  gtk_box_pack_start(GTK_BOX(hbox1), label1, FALSE, FALSE, 1);
  ent_ext2 = gtk_entry_new();
  gtk_entry_set_width_chars(GTK_ENTRY(ent_ext2), 2);
  sprintf(str, "%d", mseemon.alt_extra);
  gtk_entry_set_text(GTK_ENTRY(ent_ext2), str);
  gtk_widget_show(ent_ext2);
  gtk_box_pack_start(GTK_BOX(hbox1), ent_ext2, TRUE, FALSE, 1);
  label1 = gtk_label_new("or larger");
  gtk_widget_show(label1);
  gtk_box_pack_start(GTK_BOX(hbox1), label1, FALSE, FALSE, 1);
  gtk_box_pack_start(GTK_BOX(vbox1), hbox1, TRUE, TRUE, 2);
  gtk_widget_show(hbox1);



  /* action area */
  hbox1 = gtk_hbox_new (FALSE, 0);

  /* cancel button */
  button = gtk_button_new_with_label ("Cancel");
  gtk_signal_connect(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(dialog_setup_click_cancel), dialog_setup);
  gtk_box_pack_start(GTK_BOX (hbox1), button, TRUE, TRUE, 2);
  gtk_widget_show(button);

  /* ok button */
  button = gtk_button_new_with_label ("Ok");
  gtk_signal_connect(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(dialog_setup_click_ok), dialog_setup);
  gtk_box_pack_start(GTK_BOX (hbox1), button, TRUE, TRUE, 2);
  gtk_widget_show(button);

  gtk_box_pack_start(GTK_BOX(action_area1), hbox1, TRUE, TRUE, 2);
  gtk_widget_show(hbox1);

  gtk_widget_show(vbox1);
  gtk_widget_show(dialog_setup);

  return(EXIT_SUCCESS);
}

/******
 * callback functions for this dialog 
 ******/

/* close dialog */
void dialog_setup_destroy (GtkWidget *widget, gpointer data)
{
  gtk_grab_remove(widget);
  //  gtk_widget_destroy(GTK_WIDGET(data));
  gtk_widget_destroy((GtkWidget*)data);
}

/* click cancel */
void dialog_setup_click_cancel (GtkWidget *widget, gpointer data)
{
  gtk_widget_destroy(GTK_WIDGET(data));
}

/* click ok
 * set interval, site lon and lat */
void dialog_setup_click_ok (GtkWidget *widget, gpointer data)
{
  gchar text[128];
  gchar* content;
  int i, d, m, s;
  int prevtime;
  double val;

  prevtime = mseemon.time_iishutter;

  content = (gchar*)gtk_entry_get_text(GTK_ENTRY(ent_intv));
  d = atoi(content);
  mseemon.time_reload1 = d;

  content = (gchar*)gtk_entry_get_text(GTK_ENTRY(ent_intv2));
  d = atoi(content);
  mseemon.time_reload2 = d;

  content = (gchar*)gtk_entry_get_text(GTK_ENTRY(ent_intv3));
  d = atoi(content);
  mseemon.time_iishutter0 = d;
  if (mseemon.time_iishutter0 > 9999) {
    mseemon.time_iishutter0 = 9999;
  }
  if (mseemon.time_iishutter0 < 1000) {
    mseemon.time_iishutter0 = 1000;
  }
  /* set time for ii shutter to new default value */
  mseemon.time_iishutter = mseemon.time_iishutter0;
  
  if (mseemon.time_iishutter != prevtime) {
    set_iishutter(mseemon.time_iishutter); /* in telctl_automatic.c */
  }
  content = (gchar*)gtk_entry_get_text(GTK_ENTRY(ent_clip));
  val = atof(content);
  mseemon.clip = val;

  content = (gchar*)gtk_entry_get_text(GTK_ENTRY(ent_wid));
  d = atoi(content);
  for (i=0; i<2; i++) {
    mseemon.star_rect[i].cx = d;
  }
  content = (gchar*)gtk_entry_get_text(GTK_ENTRY(ent_hgt));
  d = atoi(content);
  for (i=0; i<2; i++) {
    mseemon.star_rect[i].cy = d;
  }

  content = (gchar*)gtk_entry_get_text(GTK_ENTRY(ent_cgwid));
  d = atoi(content);
  for (i=0; i<2; i++) {
    mseemon.cg_rect[i].cx = d;
  }
  content = (gchar*)gtk_entry_get_text(GTK_ENTRY(ent_cghgt));
  d = atoi(content);
  for (i=0; i<2; i++) {
    mseemon.cg_rect[i].cy = d;
  }

  content = (gchar*)gtk_entry_get_text(GTK_ENTRY(ent_bgsig));
  val = atof(content);
  bgthr = val;

  content = (gchar*)gtk_entry_get_text(GTK_ENTRY(ent_minpeak));
  d = atoi(content);
  mseemon.min_peak = d;

  content = (gchar*)gtk_entry_get_text(GTK_ENTRY(ent_fndr_targetx));
  d = atoi(content);
  mseemon.finder_targetpos.cx = d;

  content = (gchar*)gtk_entry_get_text(GTK_ENTRY(ent_fndr_targety));
  d = atoi(content);
  mseemon.finder_targetpos.cy = d;

  content = (gchar*)gtk_entry_get_text(GTK_ENTRY(ent1));
  d = atoi(content);
  content = (gchar*)gtk_entry_get_text(GTK_ENTRY(ent2));
  m = atoi(content);
  content = (gchar*)gtk_entry_get_text(GTK_ENTRY(ent3));
  s = atoi(content);
  msite.slon = (double)d + m/60. + s/3600.;

  content = (gchar*)gtk_entry_get_text(GTK_ENTRY(ent4));
  d = atoi(content);
  content = (gchar*)gtk_entry_get_text(GTK_ENTRY(ent5));
  m = atoi(content);
  content = (gchar*)gtk_entry_get_text(GTK_ENTRY(ent6));
  s = atoi(content);
  msite.slat = (double)d + m/60. + s/3600.;

  /* added v0.5.10 20040802 iwata */
  content = (gchar*)gtk_entry_get_text(GTK_ENTRY(ent_ext1));
  mseemon.high_extra = atoi(content);
  content = (gchar*)gtk_entry_get_text(GTK_ENTRY(ent_ext2));
  mseemon.alt_extra = atoi(content);
  /* check */
  if (mseemon.alt_extra < 0) {
    printf("# too small altitude. set to 0.\n");
    mseemon.alt_extra = 0;
  }
  if (mseemon.alt_extra > 90) {
    printf("# too large altitude. set to 90.\n");
    mseemon.alt_extra = 90;
  }

  /* check if interval is too short 
   * added ver.0.5.1 2003.10.02 */
  if (mseemon.time_reload1 < 500) {
    printf("DV reload interval too short! should be longer than 499msec.\n");
    mseemon.time_reload1 = 500;
  }
  if (mseemon.time_reload2 < 1000) {
    printf("analysis interval too short! should be longer than 999msec.\n");
    mseemon.time_reload2 = 1000;
  }

  #ifdef DEBUG
  printf("New Reload Interval:    %d msec.\n", mseemon.time_reload);
  //  printf("New Reset Sky Interval: %d times.\n", mseemon.time_sky);
  printf("New IICCD Shutter Interval:    %d msec.\n", mseemon.time_iishutter);
  printf("New Rect. Size: %d x %d.\n", mseemon.star_rect[0].cx, mseemon.star_rect[0].cy);
  printf("New Peak Threshold: %4d\n", mseemon.min_peak);
  printf("New Finder Target Pos.: %4d %4d\n", mseemon.finder_targetpos.cx, mseemon.finder_targetpos.cy);
  printf("New Site Location: lon:%8.4f lat:%8.4f\n", msite.slon, msite.slat);
  printf("New Factor for Tel.Motion: %d for alt larger than %d.\n", mseemon.high_extra, mseemon.alt_extra);
  #endif

  /* reset timer */
  if (mseemon.is_capturing > 0) { /* if capture window is open */
    if (mseemon.is_capturing == 1) {
      mseemon.time_reload = mseemon.time_reload1;
    } else {
      mseemon.time_reload = mseemon.time_reload2;
    }
    if (timertag != -1) {
      /* stop current working timer */
      stoptimer();
    }
    starttimer();
  }

  /* memory allocation for new rect. boxes */
  for (i=0; i < 2; i++) {
    /* temporary stop calc. cg */
    d = flg_set_rect[i];
    flg_set_rect[i] = 0;
    if ((alloc_rect(i, mseemon.star_rect[i].cx, mseemon.star_rect[i].cy)) == EXIT_FAILURE) {
      printf("error occured during memory allocation.\n");
      //      exit(0);
      // modified 20041209 v0.6.5 iwata
      return;
    }
    /* resume flg */
    flg_set_rect[i] = d;
  }

  /* update object list */
  /* added v0.5.8 2004.02.23 */
  update_object_list(); /* ib obj.c */

  gtk_widget_destroy(GTK_WIDGET(data));
}

/* read finder target position from a file
 * added on v0.5.6 2004.02.20 
 */
int get_finder_target_pos(void) {
  FILE *fp;
  int ct = 0, tx, ty;
  char buf[256];
  
  if ((fp = fopen(tgtpath, "r")) == NULL) {
    printf("# failed in opening %s.\n", tgtpath);
    if (fout != NULL) {
      fprintf(fout, "# failed in opening %s.\n", tgtpath);
    }
    mseemon.finder_targetpos.cx = -999;
    mseemon.finder_targetpos.cy = -999;
    return(EXIT_FAILURE);
  } else {
    while (fgets(buf, 256, fp)) {
      if (ct == 0) {
	ct++;
	sscanf(buf, "%d %d", &tx, &ty);
	mseemon.finder_targetpos.cx = tx;
	mseemon.finder_targetpos.cy = ty;
	printf("# finder target position: %d %d\n", tx, ty);
	if (fout != NULL) {
	  fprintf(fout, "# finder target position: %d %d\n", tx, ty);
	}
      }
    }
    fclose(fp);
  }

  return(EXIT_SUCCESS);
}

/* write finder target position to a file
 * added on v0.5.6 2004.02.20 
 */
int set_finder_target_pos(void) {
  FILE *fp;

  if ((fp = fopen(tgtpath, "w")) == NULL) {
    printf("# failed in opening %s.\n", tgtpath);
    return(EXIT_FAILURE);
  }

  fprintf(fp, "%d %d\n", mseemon.finder_targetpos.cx, mseemon.finder_targetpos.cy);

  fclose(fp);

  #ifdef DEBUG
  printf("# finished writing the finder target position to %s.\n", tgtpath);
  #endif

  return(EXIT_SUCCESS);
}

/* filepath set dialog */
void callback_setfilepath (GtkWidget *widget, gpointer data)
{
  GtkWidget *fdialog;

  fdialog = gtk_file_selection_new("Object File");

  gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(fdialog)->ok_button), "clicked", GTK_SIGNAL_FUNC(filepath_click_ok), GTK_OBJECT(fdialog));

  gtk_file_selection_set_filename(GTK_FILE_SELECTION(fdialog), edbpath);

  g_signal_connect_swapped(GTK_OBJECT(GTK_FILE_SELECTION(fdialog)->cancel_button), "clicked", G_CALLBACK(gtk_widget_destroy), (gpointer)fdialog);


  gtk_widget_show(fdialog);

  gtk_grab_add(GTK_WIDGET(fdialog));

}

void filepath_click_ok(GtkWidget *widget, gpointer data) {
  gchar *filepath;

  filepath = strdup(gtk_file_selection_get_filename(GTK_FILE_SELECTION(data)));

  #ifdef DEBUG
  printf("selected: %s\n", filepath);
  #endif
  strcpy(edbpath, filepath);

  /* update display */
  gtk_entry_set_text(GTK_ENTRY(ent7), edbpath);

  gtk_widget_destroy(GTK_WIDGET(data));
}


/* read settings from a configuration file 
 * 20041203 iwata 
 * 20041208 iwata v0.6.5 added alt_limit1, alt_limit2
 */
int read_config(char* fname) {
  FILE *fp;
  char buf[256];
  int line = 1;
  int pt = 0;

  if ((fp = fopen(fname, "r")) == NULL) {
    printf("failed in opening %s.\n", fname);
    return(EXIT_FAILURE);
  }

  while (fgets(buf, 256, fp)) {
    if (buf[0] != '#' && buf[0] != '\0') {
      switch(line) {
      case 1:
	mseemon.dimm_id = atoi(buf);
	break;
      case 2:
	while (pt>=0 && pt < 30) {
	  if (buf[pt] != '\0' && buf[pt] != '\n') {
	    socket_server[pt] = buf[pt];
	    pt++;
	  } else {
	    pt = -1;
	  }
	}
	break;
      case 3:
	mseemon.time_iishutter = atoi(buf);
	break;
      case 4:
	mseemon.high_extra = atoi(buf);
	break;
      case 5:
	mseemon.alt_extra = atoi(buf);
	break;
      case 6:
	mseemon.endtime = atof(buf);
	break;
      case 7:
	mseemon.alt_limit1 = (float)atof(buf);
	break;
      case 8:
	mseemon.alt_limit2 = (float)atof(buf);
	break;
      }
      line++;
    }
  }
  fclose(fp);

  #ifdef DEBUG
  printf("# read from %s:\n", fname);
  printf("# dimm_id = %d.\n", mseemon.dimm_id);
  printf("# socket server:%s.\n", socket_server);
  printf("# default IICCD shutter speed = %d.\n", mseemon.time_iishutter);
  printf("# guide acceleration: x%d for altitude higher than %d.\n", mseemon.high_extra, mseemon.alt_extra);
  //  printf("# typical image distance = %6.2f pix.\n", mseemon.image_dist);
  printf("# end time for auto mode = %5.2f.\n", mseemon.endtime);
  printf("# low limit for selecting star = %5.2f.\n", mseemon.alt_limit1);
  printf("# low limit for tracking  star = %5.2f.\n", mseemon.alt_limit2);
  #endif

  return(EXIT_SUCCESS);
}
