/* 
 * telescope control dialog (actually window)
 *
 * 2002.12.03 -
 * Time-stamp: <2003-09-11 15:19:30 dimm>
 *
 */
#include <stdlib.h>
#include <gtk/gtk.h>

#include "seemon2.h"
#include "protocol.h"

/* initialization of telescope control window 
 *
 */
int init_telctl_window(GtkWidget *window_telctl) {
  GtkWidget *button;
  GtkWidget *hbox1, *vbox1;
  gchar str[4];
  // int dir[4];
  int focusdir[2];

  focusdir[0] = 0;
  focusdir[1] = 1;

  hbox1 = gtk_hbox_new (FALSE, 0);
  vbox1 = gtk_vbox_new (FALSE, 0);

  gtk_container_add (GTK_CONTAINER (window_telctl), vbox1);

  /* Up button */
  mseemon.tel_dir[0] = 1;
  button = gtk_button_new_with_label ("  N  ");
  g_signal_connect (G_OBJECT (button), "pressed",
		    G_CALLBACK (callback_tel_ctl), (gpointer)&mseemon.tel_dir[0]);  
  g_signal_connect (G_OBJECT (button), "released",
		    G_CALLBACK (callback_tel_ctlstop), (gpointer)&mseemon.tel_dir[0]);
  gtk_box_pack_start(GTK_BOX (hbox1), button, TRUE, FALSE, 0);
  gtk_widget_show(button);
  gtk_box_pack_start(GTK_BOX(vbox1), hbox1, TRUE, TRUE, 0);
  gtk_widget_show(hbox1);

  hbox1 = gtk_hbox_new (FALSE, 0);

  /* Left button */
  mseemon.tel_dir[1] = 2;
  button = gtk_button_new_with_label ("  E  ");
  g_signal_connect (G_OBJECT (button), "pressed",
		    G_CALLBACK (callback_tel_ctl), (gpointer)&mseemon.tel_dir[1]);
  g_signal_connect (G_OBJECT (button), "released",
		    G_CALLBACK (callback_tel_ctlstop), (gpointer)&mseemon.tel_dir[1]);
  gtk_box_pack_start(GTK_BOX (hbox1), button, TRUE, FALSE, 0);
  gtk_widget_show(button);

  /* center */
  button = gtk_button_new_with_label ("     ");
  gtk_box_pack_start(GTK_BOX (hbox1), button, TRUE, FALSE, 0);
  gtk_widget_show(button);

  /* Right button */
  mseemon.tel_dir[2] = 3;
  button = gtk_button_new_with_label ("  W  ");
  g_signal_connect (G_OBJECT (button), "pressed",
		    G_CALLBACK (callback_tel_ctl), (gpointer)&mseemon.tel_dir[2]);
  g_signal_connect (G_OBJECT (button), "released",
		    G_CALLBACK (callback_tel_ctlstop), (gpointer)&mseemon.tel_dir[2]);
  gtk_box_pack_start(GTK_BOX (hbox1), button, TRUE, FALSE, 0);
  gtk_widget_show(button);
  gtk_box_pack_start(GTK_BOX(vbox1), hbox1, TRUE, TRUE, 0);
  gtk_widget_show(hbox1);

  hbox1 = gtk_hbox_new (FALSE, 0);

  /* Down button */
  mseemon.tel_dir[3] = 4;
  button = gtk_button_new_with_label ("  S  ");
  g_signal_connect (G_OBJECT (button), "pressed",
		    G_CALLBACK (callback_tel_ctl), (gpointer)&mseemon.tel_dir[3]);
  g_signal_connect (G_OBJECT (button), "released",
		    G_CALLBACK (callback_tel_ctlstop), (gpointer)&mseemon.tel_dir[3]);
  gtk_box_pack_start(GTK_BOX (hbox1), button, TRUE, FALSE, 0);
  gtk_widget_show(button);
  gtk_box_pack_start(GTK_BOX(vbox1), hbox1, TRUE, TRUE, 0);
  gtk_widget_show(hbox1);

  //  #ifdef DEBUG
  //  printf("%p %p %p %p\n", &dir[0], &dir[1], &dir[2], &dir[3]);
  //  #endif

  /* Toggle Buttons for Motion Step */
  hbox1 = gtk_hbox_new (FALSE, 0);
  button = gtk_toggle_button_new_with_label ("GUIDE");
  g_signal_connect (G_OBJECT (button), "clicked",
		    G_CALLBACK (callback_tel_setstep1), (gpointer)button);
  gtk_box_pack_start(GTK_BOX (hbox1), button, TRUE, FALSE, 0);
  gtk_widget_show(button);
  /* set current selected toggle button */
  if (mseemon.tel_step == GUIDE) {
    toggle_cstep = button;
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), TRUE);
  }

  button = gtk_toggle_button_new_with_label ("CENTER");
  g_signal_connect (G_OBJECT (button), "clicked",
		    G_CALLBACK (callback_tel_setstep2), (gpointer)button);
  gtk_box_pack_start(GTK_BOX (hbox1), button, TRUE, FALSE, 0);
  gtk_widget_show(button);
  /* set current selected toggle button */
  if (mseemon.tel_step == CENTER) {
    toggle_cstep = button;
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), TRUE);
  }

  button = gtk_toggle_button_new_with_label ("FIND");
  g_signal_connect (G_OBJECT (button), "clicked",
		    G_CALLBACK (callback_tel_setstep3), (gpointer)button);
  gtk_box_pack_start(GTK_BOX (hbox1), button, TRUE, FALSE, 0);
  gtk_widget_show(button);
  /* set current selected toggle button */
  if (mseemon.tel_step == FIND) {
    toggle_cstep = button;
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), TRUE);
  }

  button = gtk_toggle_button_new_with_label ("SLEW");
  g_signal_connect (G_OBJECT (button), "clicked",
		    G_CALLBACK (callback_tel_setstep4), (gpointer)button);
  gtk_box_pack_start(GTK_BOX (hbox1), button, TRUE, FALSE, 0);
  gtk_widget_show(button);
  /* set current selected toggle button */
  if (mseemon.tel_step == SLEW) {
    toggle_cstep = button;
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), TRUE);
  }

  gtk_box_pack_start(GTK_BOX(vbox1), hbox1, TRUE, TRUE, 0);
  gtk_widget_show(hbox1);

  /* focus controls. v0.5.0 2003.09.11 */
  hbox1 = gtk_hbox_new (FALSE, 0);
  button = gtk_button_new_with_label ("Focus +");
  g_signal_connect (G_OBJECT (button), "pressed",
		    G_CALLBACK (callback_focus_pos), (gpointer)&focusdir[0]);
  g_signal_connect (G_OBJECT (button), "released",
		    G_CALLBACK (callback_focusstop), (gpointer)&focusdir[0]);
  gtk_box_pack_start(GTK_BOX (hbox1), button, TRUE, TRUE, 0);
  gtk_widget_show(button);

  button = gtk_button_new_with_label ("Focus -");
  g_signal_connect (G_OBJECT (button), "pressed",
		    G_CALLBACK (callback_focus_neg), (gpointer)&focusdir[1]);
  g_signal_connect (G_OBJECT (button), "released",
		    G_CALLBACK (callback_focusstop), (gpointer)&focusdir[1]);
  gtk_box_pack_start(GTK_BOX (hbox1), button, TRUE, TRUE, 0);
  gtk_widget_show(button);

  gtk_box_pack_start(GTK_BOX(vbox1), hbox1, TRUE, TRUE, 0);
  gtk_widget_show(hbox1);
  
  /* Close Window button */
  hbox1 = gtk_hbox_new (FALSE, 0);
  button = gtk_button_new_with_label ("Close");
  g_signal_connect (G_OBJECT (button), "clicked",
		    G_CALLBACK (callback_hide_window), window_telctl);
  gtk_box_pack_start(GTK_BOX (hbox1), button, TRUE, TRUE, 0);
  gtk_widget_show(button);
  gtk_box_pack_start(GTK_BOX(vbox1), hbox1, TRUE, TRUE, 0);
  gtk_widget_show(hbox1);

  gtk_widget_show(vbox1);

  return(EXIT_SUCCESS);
}
